"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpeechMarkdown = void 0;
var factory = __importStar(require("./formatters/FormatterFactory"));
var SpeechMarkdownParser_1 = require("./SpeechMarkdownParser");
var SpeechMarkdown = /** @class */ (function () {
    function SpeechMarkdown(options) {
        this.options = options;
        this.defaults = {
            includeFormatterComment: false,
            includeParagraphTag: false,
            includeSpeakTag: true,
            platform: '',
            preserveEmptyLines: true,
        };
        this.options = __assign(__assign({}, this.defaults), options);
    }
    Object.defineProperty(SpeechMarkdown.prototype, "Parser", {
        get: function () {
            if (!this.parser) {
                this.parser = new SpeechMarkdownParser_1.SpeechMarkdownParser();
            }
            return this.parser;
        },
        enumerable: false,
        configurable: true
    });
    SpeechMarkdown.prototype.toText = function (speechmarkdown, options) {
        var methodOptions = __assign(__assign({}, this.options), options);
        var ast = this.Parser.parse(speechmarkdown);
        var formatter = factory.createTextFormatter(methodOptions);
        return formatter.format(ast);
    };
    SpeechMarkdown.prototype.toSSML = function (speechmarkdown, options) {
        var methodOptions = __assign(__assign({}, this.options), options);
        var ast = this.Parser.parse(speechmarkdown);
        // console.log(`AST: ${ast}`);
        var formatter = factory.createFormatter(methodOptions);
        return formatter.format(ast);
    };
    SpeechMarkdown.prototype.toAST = function (speechmarkdown) {
        return this.Parser.parse(speechmarkdown);
    };
    SpeechMarkdown.prototype.toASTString = function (speechmarkdown) {
        var ast = this.Parser.parse(speechmarkdown);
        return ast.toString();
    };
    return SpeechMarkdown;
}());
exports.SpeechMarkdown = SpeechMarkdown;
//# sourceMappingURL=SpeechMarkdown.js.map